using Autofac;
using FitConnect;
using Microsoft.Extensions.Logging;
using MockContainer;
using NUnit.Framework;

namespace FluentApiTest;

public class FluentSubscriberReceiveTests {
    private readonly string clientId = "clientId";
    private readonly string clientSecret = "clientSecret";
    private Client _client = null!;
    private IContainer _container = null!;
    private ILogger _logger = null!;
    private MockSettings _mockSettings = null!;

    [OneTimeSetUp]
    public void OneTimeSetup() {
        _container = Container.Create();
        _logger = _container.Resolve<ILogger>();
        _mockSettings = _container.Resolve<MockSettings>();
    }

    [SetUp]
    public void SetUp() {
        _client = new Client(
            FitConnectEnvironment.Development, clientId,
            clientSecret, container: _container, logger: _logger);
    }

    [Test]
    [Ignore("Missing encrypted data")]
    public void GetSubmission() {
        var submissions = _client.GetSubscriber("", "")
            .GetAvailableSubmissions();

        var attachments = _client.GetSubscriber(_mockSettings.PrivateKeyDecryption,
                _mockSettings.PrivateKeySigning)
            .RequestSubmission("submissionId")
            .GetAttachments();
    }
}
